#!/usr/bin/perl
my $DESCRIPTION = <<PERLHEREDOC;
########################################################################
########################################################################
PERLHEREDOC

$|++;
use strict;
use WWW::Mechanize;
use Data::Dumper;#DEBUG

# ΏۂƂȂhC
my $MYDOMAIN =      'http://www.example.com/';

# N[Ȃt@C̊gq
my $ignore_exts = join '|',
    qw( jpeg jpg gif png css rdf lzh zip rar pdf pl txt cgi xml js exe com pbp php html xml xsl ppt asc );

# rel="nofollow" ̃NłPageRanǩvZɍlꍇɂ 1
my $COUNT_NOFOLLOW = 0;



########################################################################
use constant CRAWL_NOT_YET              => 0;
use constant CRAWL_DONE                 => 1;
use constant CRAWL_ERROR                => -1;

### y[WN[p̃L[
my %crawl_cue = ( $MYDOMAIN => CRAWL_NOT_YET );

### N֌W̃}gNX
my $linked_matrix = {};

### N[ݒ
my $mech = new WWW::Mechanize
    or die '';

########################################################################
my $loop;
do {
    $loop = 0;
    foreach my $url (sort keys %crawl_cue) {
        # łɃN[ς݂ȂXLbv
        next if $crawl_cue{$url} != CRAWL_NOT_YET;
        # 擾݂
        printf STDERR "%d/%d ",
                (scalar grep { $crawl_cue{$_} != CRAWL_NOT_YET } keys %crawl_cue),
                (scalar keys %crawl_cue);
        printf STDOUT "%s",
                normalize_url( $url );
        my $res = $mech->get( $url );
        sleep 1;
        unless( $res && $res->is_success) {
            # s orz
            printf STDOUT " - Failed : %s\n", $res->status_line;
            $crawl_cue{$url} = CRAWL_ERROR;
            next;
        }
        printf STDOUT " - OK : %d bytes\n", length $res->content;
        $crawl_cue{$url} = CRAWL_DONE;

        # hC̃y[W̃N𒲂ׂ
        my @links = $mech->find_all_links( url_abs_regex => qr/^\Q$MYDOMAIN\E/ );
        foreach my $link (@links) {
            my $url2 = $link->url_abs();
            $url2 =~ s![\?#].*$!!;  # NGAJ[
            # gւ̃N͊܂߂Ȃ
            next if $url2 eq $url;
            # nofollow ̃Nׂ͒Ȃ
            if( !$COUNT_NOFOLLOW && $link->attrs()->{rel} eq 'nofollow' ) {
                print STDERR "x";
                next;
            }
            # HTMLy[WȊOׂ͒Ȃ
            if ($url2 =~ m/\.(?:$ignore_exts)$/i) {
                print STDERR ">";
                next;
            }
            # N[Ώۂɒǉ
            if( !defined $crawl_cue{$url2} ) {
                print STDERR "+";
                $crawl_cue{$url2} = CRAWL_NOT_YET;
            } else {
#                print STDERR ".";
            }
            # }gNXɋL^F$url  $url2 ɃN
            $linked_matrix->{$url}->{$url2} = 1;
        } #foreach
        print STDERR "\n";
        $loop++;
    } #foreach
} while( $loop );



my @all_links = sort keys %$linked_matrix;
my $link_num = scalar @all_links;

open (my $fh, ">link_matrix.txt")
    or die "Failed to open output file.";
foreach my $i ( 0..$link_num-1 ) {
    print STDERR ".";
    my $url1 = $all_links[$i];
    print $fh $i. ','. normalize_url( $url1 );
    foreach my $j ( 0..$link_num-1 ) {
        my $url2 = $all_links[$j];
        print $fh ','. ( $linked_matrix->{$url1}->{$url2} ? '1' : '0' );
    }
    print $fh "\n";
}
print STDERR "\n";
close $fh;



sub normalize_url {
    my $url = shift; $url =~ s!^\Q$MYDOMAIN\E!/!; $url;
}
